C     PROGRAM BISEC
C
C     BISECTION METHOD
C
      DOUBLE PRECISION F,A,B,EPS,X,FX,E
      EXTERNAL F
      READ(5,*) A,B,NIT,EPS
      WRITE(6,*) 'INPUT:'
      WRITE(6,*) 'A=',A,' B=',B
      WRITE(6,*) 'NIT=',NIT,' EPS=',EPS
      WRITE(6,*) ' '
      WRITE(6,*) 'OUTPUT:'
      CALL BISECT(F,A,B,NIT,EPS,X,FX,E,KIT,ITEST)
      WRITE(6,*) 'ITEST=',ITEST,' KIT=',KIT
      WRITE(6,*) 'X=',X,' FX=',FX
      WRITE(6,*) 'E=',E
      STOP
      END
C-----------------------------------------------------------------
      SUBROUTINE BISECT(F,A,B,NIT,EPS,X,FX,E,KIT,ITEST)
C      
C     SOLUTION OF THE EQUATION F(X)=0 BY THE BISECTION METHOD
C
C     USES D.P. FUNCTION F
C
C     INPUT:
C     F: FUNCTION     
C     [A,B]: SEARCH INTERVAL 
C     NIT: MAXIMUM NUMBER OF ITERATIONS
C     EPS: ERROR TEST NUMBER
C        
C     OUTPUT:
C     X: APPROXIMATE ROOT
C     FX:=F(X)
C     E: ERROR BOUND
C     KIT: NUMBER OF EXECUTED ITERATIONS 
C     ITEST = 0, F(A)F(B)>0
C           = 1, ERROR TEST SATISFIED
C           = 2, ERROR TEST NOT SATISFIED 
C             
      DOUBLE PRECISION F,A,B,EPS,X,FX,FA,FB,E,P
      EXTERNAL F
      ITEST=1
      E=B-A
      FA=F(A)
      FB=F(B)
      P=FA*FB
      IF(P.GT.0.D0) GO TO 40
C
      DO 10 K=0,NIT
      KIT=K
      X=A+E/2.D0
      FX=F(X)
      WRITE(6,*) 'K=',K,' X=',X,' FX=',FX
      P=FA*FX
      IF(P.LE.0.D0) GO TO 20
      A=X
      FA=FX
      GO TO 30
   20 B=X
      FB=FX
   30 E=B-A
      IF(E.LE.EPS) RETURN
   10 CONTINUE
      ITEST=2
      RETURN
   40 ITEST=0
      RETURN
      END
C-----------------------------------------------------------------
      DOUBLE PRECISION FUNCTION F(X)
      DOUBLE PRECISION X
      F=X-DCOS(X)
      RETURN
      END
