C     PROGRAM INTER 
C
C     LAGRANGE-NEWTON INTERPOLATION POLYNOMIAL
C
      PARAMETER(ND=10)
      DOUBLE PRECISION A,X,Y,Z,P,D
      DIMENSION A(ND),X(ND),Y(ND),D(ND)
      READ(5,*) N,IOPT,Z
      NP=N+1
      READ(5,*) (X(I),I=1,NP)
      READ(5,*) (Y(I),I=1,NP)
      WRITE(6,*) 'INPUT:'
      WRITE(6,*) 'N=',N,' IOPT=',IOPT
      WRITE(6,*) 'Z=',Z
      WRITE(6,*) 'X=',(X(I),I=1,NP)
      WRITE(6,*) 'Y=',(Y(I),I=1,NP)
      WRITE(6,*) ' '
      WRITE(6,*) 'OUTPUT:'
      CALL INTERP(ND,N,IOPT,X,Y,Z,A,P,D)
      WRITE(6,*) 'A=',(A(I),I=1,NP)
      WRITE(6,*) 'P=',P
      STOP
      END
C-----------------------------------------------------------------
      SUBROUTINE INTERP(ND,N,IOPT,X,Y,Z,A,P,D)
C
C     COMPUTATION OF THE COEFFICIENTS OF THE LAGRANGE
C     INTERPOLATION POLYNOMIAL IN NEWTON FORM, AND
C     EVALUATION OF THE POLYNOMIAL
C
C     INPUT: 
C     ND: MAXIMUM DIMENSION OF ARRAYS 
C     N: POLYNOMIAL DEGREE
C     IOPT = 0, COMPUTATION OF COEFFICIENTS AND EVALUATION OF P
C          = 1, COMPUTATION OF COEFFICIENTS ONLY
C          = 2, EVALUATION OF P ONLY (WITH KNOWN COEFFICIENTS)
C     X: VECTOR OF INTERPOLATION POINTS (N+1)
C     Y: VECTOR OF VALUES (N+1)
C     Z: VARIABLE VALUE (IF IOPT=0 OR 2)
C
C     OUTPUT:
C     A: POLYNOMIAL COEFFICIENTS (N+1)
C     P: VALUE OF THE POLYNOMIAL AT Z (IF IOPT=0 OR 2)
C        
      DOUBLE PRECISION A,X,Y,Z,P,D
      DIMENSION A(ND),X(ND),Y(ND),D(ND)
      NP=N+1
      IF(IOPT.EQ.2) GO TO 30
C
C     COMPUTATION OF THE COEFFICIENTS
C
      D(1)=Y(1)
      A(1)=Y(1)
      DO 10 K=2,NP
         D(K)=Y(K)
         DO 20 J=2,K
         I=K+1-J
   20    D(I)=(D(I+1)-D(I))/(X(K)-X(I))
   10 A(K)=D(1)
      IF(IOPT.EQ.1) RETURN
C      
C     EVALUATION OF THE POLYNOMIAL
C
   30 P=A(NP)
      N=NP-1
      DO 40 I=1,N
      J=NP-I 
   40 P=(Z-X(J))*P+A(J)
      RETURN
      END

         

