C     PROGRAM NEWTC 
C
C     COMPLEX NEWTON METHOD
C
      COMPLEX*16 F,DF,Z,FZ
      DOUBLE PRECISION EPS
      EXTERNAL F,DF
      READ(5,*) M,NIT,EPS,Z
      WRITE(6,*) 'INPUT:'
      WRITE(6,*) 'M=',M,' NIT=',NIT,' EPS=',EPS
      WRITE(6,*) 'Z=',Z
      WRITE(6,*) ' '
      WRITE(6,*) 'OUTPUT:'
      CALL NEWTCOM(F,DF,M,NIT,EPS,Z,FZ,KIT,ITEST)
      WRITE(6,*) 'ITEST=',ITEST,' KIT=',KIT
      IF(ITEST.EQ.0) STOP
      WRITE(6,*) 'Z=',Z
      WRITE(6,*) 'FZ=',FZ
      STOP
      END
C-----------------------------------------------------------------
      SUBROUTINE NEWTCOM(F,DF,M,NIT,EPS,Z,FZ,KIT,ITEST)
C
C     SOLUTION OF THE COMPLEX EQUATION F(Z)=0 BY NEWTON'S METHOD
C
C     USES COMPLEX*16 FUNCTIONS F AND DF 
C
C     INPUT:
C     F: COMPLEX FUNCTION
C     DF: COMPLEX DERIVATIVE OF F
C     M: ROOT MULTIPLICITY PARAMETER
C     NIT: MAXIMUM NUMBER OF ITERATIONS
C     EPS: CONVERGENCE TEST NUMBER
C     Z: INITIAL COMPLEX NUMBER
C  
C     OUTPUT:
C     Z: APPROXIMATE ROOT
C     FZ:=F(Z)
C     KIT: NUMBER OF EXECUTED ITERATIONS
C     ITEST = 0, ZERO DERIVATIVE (DIVISION BY ZERO)
C           = 1, CONVERGENCE TEST SATISFIED
C           = 2, CONVERGENCE TEST NOT SATISFIED 
C
      COMPLEX*16 F,DF,Z,Y,FZ,DFZ
      DOUBLE PRECISION EPS,EE
      EXTERNAL F,DF
      EE=1.D-99
      ITEST=1
C
      DO 10 K=1,NIT
      KIT=K
      FZ=F(Z)
      DFZ=DF(Z)
      IF(CDABS(DFZ).LE.EE) GO TO 20
      Y=Z
      Z=Z-DFLOAT(M)*FZ/DFZ
      WRITE(6,*) 'K=',K,'  Z=',Z
      IF(CDABS(Z-Y).LE.EPS) RETURN
   10 CONTINUE
      ITEST=2
      RETURN
   20 ITEST=0
      RETURN
      END
C-----------------------------------------------------------------
      COMPLEX*16 FUNCTION F(Z)
      COMPLEX*16 Z
      F=(Z*Z+1.D0)**2
      RETURN
      END
C-----------------------------------------------------------------
      COMPLEX*16 FUNCTION DF(Z)
      COMPLEX*16 Z
      DF=4.D0*Z*(Z*Z+1.D0)
      RETURN
      END
