C     PROGRAM POWE 
C
C     POWER METHOD 
C
      PARAMETER(ND=10)
      DOUBLE PRECISION EPS,A,V,X,Y,R
      DIMENSION A(ND,ND),V(ND),X(ND),Y(ND)
      READ(5,*) N,NIT,EPS
      READ(5,*) ((A(I,J),J=1,N),I=1,N)
      READ(5,*) (V(I),I=1,N)
      WRITE(6,*) 'INPUT:'
      WRITE(6,*) 'N=',N,' NIT=',NIT,' EPS=',EPS
      WRITE(6,*) 'A='
      DO 10 I=1,N
      WRITE(6,*) (A(I,J),J=1,N)
   10 WRITE(6,*) ' '
      WRITE(6,*) 'V=',(V(I),I=1,N)
      WRITE(6,*) ' '
      WRITE(6,*) 'OUTPUT:'
C
      DO 20 L=1,N
      WRITE(6,*) 'L=',L
      CALL POWER(ND,N,A,V,NIT,EPS,X,R,KIT,ITEST,Y)
      WRITE(6,*) 'ITEST=',ITEST
      WRITE(6,*) 'KIT=',KIT
      IF(ITEST.EQ.0) STOP
      WRITE(6,*) 'R=',R
      WRITE(6,*) 'X=',(X(I),I=1,N)
   20 WRITE(6,*) ' '
      STOP
      END
C------------------------------------------------------------------
      SUBROUTINE POWER(ND,N,A,V,NIT,EPS,X,R,KIT,ITEST,Y)
C     
C     COMPUTATION OF THE LARGEST EIGENVALUE AND OF A CORRESPONDENT 
C     EIGENVECTOR (WITH NORM 1) OF THE MATRIX A BY THE POWER METHOD.
C     COMPUTATION OF THE MODIFIED MATRIX A.
C   
C     INPUT:
C     A: MATRIX (NXN)
C     V: INITIAL VECTOR (N)
C     ND: MAXIMUM COLUMN DIMENSION OF ARRAYS
C     N: DIMENSION OF ARRAYS
C     NIT: MAXIMUM NUMBER OF ITERATIONS
C     EPS: CONVERGENCE TEST NUMBER
C
C     OUTPUT:
C     X: APPROXIMATE EIGENVECTOR (N)       
C     R: APPROXIMATE LARGEST EIGENVALUE (IN ABSOLUTE VALUE)
C     KIT: NUMBER OF EXECUTED ITERATIONS
C     ITEST = 0, ZERO VECTOR ITERATE (X)
C           = 1, CONVERGENCE TEST SATISFIED
C           = 2, CONVERGENCE TEST NOT SATISFIED
C     
      DOUBLE PRECISION EPS,A,V,X,Y,RR,R,S,T,EE
      DIMENSION A(ND,N),V(ND),X(ND),Y(ND)
      EE=1.D-99
      DO 40 I=1,N
   40 X(I)=V(I)
      RR=1.D99
C
C     ITERATIONS
C
      DO 60 K=1,NIT
      KIT=K
      M=1
      S=0.D0
         DO 70 I=1,N
         Y(I)=0.D0
            DO 80 J=1,N
   80       Y(I)=Y(I)+A(I,J)*X(J)
         T=DABS(X(I))
         IF(T.LE.S) GO TO 70
         M=I
         S=T
   70    CONTINUE
      IF(DABS(S).LE.EE) GO TO 20
      R=Y(M)/X(M)
      S=0.D0
         DO 90 I=1,N
   90    S=S+Y(I)**2
      S=DSQRT(S)
         DO 50 I=1,N
   50    X(I)=Y(I)/S
      IF(DABS(R-RR).LE.EPS) GO TO 30
      RR=R
   60 CONTINUE
      ITEST=2 
      GO TO 100
   20 ITEST=0
      RETURN    
   30 ITEST=1
C
C     MODIFIED MATRIX  A=A-R(XT)X
C
  100 DO 110 I=1,N
         DO 110 J=1,N
  110    A(I,J)=A(I,J)-R*X(I)*X(J)
      RETURN
      END

