C     PROGRAM RKS4 
C
C     FOURTH ORDER RUNGE-KUTTA METHOD FOR SYSTEMS
C
      PARAMETER(ND=10)
      DOUBLE PRECISION A,B,H,X,Y,V,Z1,Z2,Z3,Z4,YZ
      DIMENSION Y(ND),V(ND),Z1(ND),Z2(ND),Z3(ND),Z4(ND),YZ(ND)
      EXTERNAL F
      READ(5,*) N,M,A,B
      READ(5,*) (Y(I),I=1,N)
      WRITE(6,*) 'INPUT:'
      WRITE(6,*) 'N=',N,' M=',M
      WRITE(6,*) 'A=',A,' B=',B
      WRITE(6,*) 'Y=',(Y(I),I=1,N)
      H=(B-A)/DFLOAT(M)
      X=A
      WRITE(6,*) ' '
      WRITE(6,*) 'OUTPUT:'
      WRITE(6,*) 'X=',X
      WRITE(6,*) '  Y=',(Y(I),I=1,N)
      DO 10 K=1,M
      CALL RKSYS4(F,X,Y,ND,N,H,V,Z1,Z2,Z3,Z4,YZ)
      WRITE(6,*) 'X=',X
   10 WRITE(6,*) '  Y=',(Y(I),I=1,N)
      STOP
      END
C-----------------------------------------------------------------
      SUBROUTINE RKSYS4(F,X,Y,ND,N,H,V,Z1,Z2,Z3,Z4,YZ)
C
C     FOURTH ORDER RUNGE-KUTTA METHOD FOR SYSTEMS (ONE STEP) 
C
C     USES SUBROUTINE F
C
C     INPUT:
C     F: VECTOR FUNCTION SUBROUTINE
C     X: INITIAL VARIABLE VALUE
C     Y: INITIAL VECTOR (N)
C     ND: MAXIMUM DIMENSION OF ARRAYS
C     N: DIMENSION OF ARRAYS
C     H: STEP SIZE
C
C     OUTPUT:
C     X:=X+H
C     Y: APPROXIMATE SOLUTON VECTOR AT X  (N)
C
      DOUBLE PRECISION H,X,XH,Y,V,Z1,Z2,Z3,Z4,YZ
      DIMENSION Y(ND),V(ND),Z1(ND),Z2(ND),Z3(ND),Z4(ND),YZ(ND)
      CALL F(ND,N,X,Y,V)
      DO 10 I=1,N
      Z1(I)=H*V(I)
   10 YZ(I)=Y(I)+Z1(I)/2.D0
      XH=X+H/2.D0
      CALL F(ND,N,XH,YZ,V)
      DO 20 I=1,N
      Z2(I)=H*V(I)
   20 YZ(I)=Y(I)+Z2(I)/2.D0
      CALL F(ND,N,XH,YZ,V)
      DO 30 I=1,N
      Z3(I)=H*V(I)
   30 YZ(I)=Y(I)+Z3(I)
      X=X+H
      CALL F(ND,N,X,YZ,V)
      DO 40 I=1,N
      Z4(I)=H*V(I)
   40 Y(I)=Y(I)+(Z1(I)+2.D0*Z2(I)+2.D0*Z3(I)+Z4(I))/6.D0
      RETURN
      END
C-----------------------------------------------------------------
      SUBROUTINE F(ND,N,X,Y,V)
      DOUBLE PRECISION X,Y,V
      DIMENSION Y(ND),V(ND)
      V(1)=DSIN(X+Y(1)+Y(2))
      V(2)=DCOS(X+Y(1)+Y(2))
      RETURN
      END
