C     PROGRAM RUNK2 
C
C     SECOND ORDER RUNGE-KUTTA METHOD
C
      DOUBLE PRECISION F,A,B,H,X,Y
      EXTERNAL F
      READ(5,*) A,B,N,Y
      WRITE(6,*) 'INPUT:'
      WRITE(6,*) 'A=',A,' B=',B
      WRITE(6,*) 'N=',N,' Y=',Y
      H=(B-A)/DFLOAT(N)
      X=A
      WRITE(6,*) ' '
      WRITE(6,*) 'OUTPUT:'
      WRITE(6,*) 'X=',X,'  Y=',Y
      DO 10 K=1,N
      CALL RUNKUT2(F,X,Y,H)
   10 WRITE(6,*) 'X=',X,'  Y=',Y
      STOP
      END
C-----------------------------------------------------------------
      SUBROUTINE RUNKUT2(F,X,Y,H)
C
C     SECOND ORDER RUNGE-KUTTA METHOD (ONE STEP)
C
C     USES D.P. FUNCTION F
C
C     INPUT:
C     F: FUNCTION
C     X: INITIAL VARIABLE VALUE
C     Y: INITIAL VALUE
C     H: STEP SIZE
C
C     OUTPUT:
C     X:=X+H
C     Y: APPROXIMATE SOLUTION AT X
C
      DOUBLE PRECISION F,H,X,Y,Z1,Z2
      EXTERNAL F
      Z1=H*F(X,Y)
      X=X+H
      Z2=H*F(X,Y+Z1)
      Y=Y+(Z1+Z2)/2.D0
      RETURN
      END
C-----------------------------------------------------------------
      DOUBLE PRECISION FUNCTION F(X,Y)
      DOUBLE PRECISION X,Y
      F=DSIN(X+Y)
      RETURN
      END
