C     PROGRAM SECAN
C
C     SECANT METHOD
C
      DOUBLE PRECISION F,EPS,Y,X,FX
      EXTERNAL F
      READ(5,*) NIT,EPS,Y,X
      WRITE(6,*) 'INPUT:'
      WRITE(6,*) 'NIT=',NIT,' EPS=',EPS
      WRITE(6,*) 'Y=',Y
      WRITE(6,*) 'X=',X
      WRITE(6,*) ' '
      WRITE(6,*) 'OUTPUT:'
      CALL SECANT(F,NIT,EPS,Y,X,FX,KIT,ITEST)
      WRITE(6,*) 'ITEST=',ITEST,' KIT=',KIT
      IF(ITEST.EQ.0) STOP
      WRITE(6,*) 'X=',X,' FX=',FX
      STOP
      END
C-----------------------------------------------------------------    
      SUBROUTINE SECANT(F,NIT,EPS,Y,X,FX,KIT,ITEST)
C
C     SOLUTION OF THE EQUATION F(X)=0 BY THE SECANT METHOD
C
C     USES D.P. FUNCTION F
C
C     INPUT:
C     F: FUNCTION
C     Y,X: INITIAL VALUES 
C     NIT: MAXIMUM NUMBER OF ITERATIONS 
C     EPS: CONVERGENCE TEST NUMBER
C
C     OUTPUT:   
C     X: APPROXIMATE ROOT 
C     FX:=F(X)
C     KIT: NUMBER OF EXECUTED ITERATIONS
C     ITEST = 0, DIVISION BY ZERO        
C           = 1, CONVERGENCE TEST SATISFIED
C           = 2, CONVERGENCE TEST NOT SATISFIED
C
      DOUBLE PRECISION F,EPS,X,Y,Z,FX,FY,D,EE
      EXTERNAL F
      EE=1.D-99
      ITEST=1
      FY=F(Y)
      FX=F(X)
C      
      DO 10 K=2,NIT
      KIT=K
      Z=X
      D=FX-FY
      IF(DABS(D).LE.EE) GO TO 20
      X=X-FX*(X-Y)/D
      Y=Z
      FY=FX
      FX=F(X)
      WRITE(6,*) 'K=',K,' X=',X,' FX=',FX
      IF(DABS(X-Y).LE.EPS) RETURN
   10 CONTINUE
      ITEST=2
      RETURN
   20 ITEST=0
      RETURN
      END
C-----------------------------------------------------------------
      DOUBLE PRECISION FUNCTION F(X)
      DOUBLE PRECISION X
      F=X-DCOS(X)
      RETURN
      END
