C     PROGRAM SIMPS 
C
C     SIMPSON'S METHOD
C
      DOUBLE PRECISION F,A,B,S
      EXTERNAL F
      READ(5,*) A,B,N
      WRITE(6,*) 'INPUT:'
      WRITE(6,*) 'A=',A,' B=',B
      WRITE(6,*) 'N=',N
      WRITE(6,*) ' '
      WRITE(6,*) 'OUTPUT:'
      CALL SIMPSON(F,A,B,N,S)
      WRITE(6,*) 'S=',S
      STOP
      END
C-----------------------------------------------------------------
      SUBROUTINE SIMPSON(F,A,B,N,S)
C
C     INTEGRATION OF THE FUNCTION F ON [A,B] BY SIMPSON'S RULE
C
C     USES D.P. FUNCTION F
C
C     INPUT:
C     F: INTEGRATED FUNCTION
C     A,B: INTEGRAL BOUNDS 
C     N: EVEN NUMBER OF STEPS
C
C     OUTPUT:
C     S: APPROXIMATE INTEGRAL OF F
C
      DOUBLE PRECISION F,A,B,H,HH,X,S,S2,S4
      EXTERNAL F
      H=(B-A)/DFLOAT(N)
      HH=H+H
      M=N/2
      S=F(A)+F(B)
      S4=0.D0
      X=A+H
      DO 20 I=1,M
      S4=S4+F(X)
   20 X=X+HH
      X=A+HH
      S2=0.D0
      MM=M-1
      DO 30 I=1,MM
      S2=S2+F(X)
   30 X=X+HH
      S=(S+4.D0*S4+2.D0*S2)*H/3.D0
      RETURN
      END
C-----------------------------------------------------------------
      DOUBLE PRECISION FUNCTION F(X)
      DOUBLE PRECISION X
      F=DEXP(X)
      RETURN
      END
