C     PROGRAM TRAPE 
C
C     TRAPEZOIDAL RULE
C
      DOUBLE PRECISION F,A,B,S
      EXTERNAL F
      READ(5,*) A,B,N
      WRITE(6,*) 'INPUT:'
      WRITE(6,*) 'A=',A,' B=',B
      WRITE(6,*) 'N=',N
      WRITE(6,*) ' '
      WRITE(6,*) 'OUTPUT:'
      CALL TRAPEZ(F,A,B,N,S)
      WRITE(6,*) 'S=',S
      STOP
      END
C-----------------------------------------------------------------
      SUBROUTINE TRAPEZ(F,A,B,N,S)
C     
C     USES D.P. FUNCTION F
C     
C     INTEGRATION OF THE FUNCTION F ON THE INTERVAL [A,B]
C     BY THE TRAPEZOIDAL RULE
C  
C     INPUT:
C     F: INTEGRATED FUNCTION
C     A,B: INTEGRAL BOUNDS
C     N: NUMBER OF STEPS
C
C     OUTPUT:
C     S: APPROXIMATE INTEGRAL OF F
C
      DOUBLE PRECISION F,A,B,S,H,X
      EXTERNAL F
      H=(B-A)/DFLOAT(N)      
      S=(F(A)+F(B))/2.D0
      X=A
      NM=N-1
      DO 20 I=1,NM
      X=X+H
   20 S=S+F(X)
      S=S*H
      RETURN
      END
C-----------------------------------------------------------------
      DOUBLE PRECISION FUNCTION F(X)
      DOUBLE PRECISION X
      F=DEXP(X)
      RETURN
      END
